<template>
  <div
      :class="['block', className]"
      :style="{
          'transform': !visible ? '' :
              step <= 4
              ? 'translate(' + cx + 'px, ' + cy + 'px)'
              : 'translate(' + left + 'px, ' + top + 'px) scale(' + lscale + ')',
          'will-change': step > 4 ? 'transform' : '',
          'display': visible ? '' : 'none'
      }"
  ></div>
</template>

<script>
export default {
  name: "BaseBrick",
  props: {
    x: Number,
    y: Number,
    tx: Number,
    ty: Number,
    l1x: Number,
    l1y: Number,
    l2x: Number,
    l2y: Number,
    step: Number,
    scale: Number,
    className: String,
    cw: Number,
    ch: Number
  },
  computed: {
    cx () {
      return this.step < 2 || this.step > 4
          ? this.x * this.step
          : this.step === 2
              ? 2 * (this.x - this.l1x)
              : 4 * (this.x - this.l2x);
    },
    cy () {
      return this.step < 2 || this.step > 4
          ? this.y * this.step
          : this.step === 2
              ? 2 * (this.y - this.l1y)
              : 4 * (this.y - this.l2y);
    },
    lscale () {
      return this.scale / this.step;
    },
    lWidth () {
      return 40 * this.step;
    },
    lHeight () {
      return 40 * this.step;
    },
    left () {
      return this.x * this.scale + this.tx;
    },
    right () {
      return this.left + this.lWidth * this.scale;
    },
    top () {
      return this.y * this.scale + this.ty;
    },
    bottom () {
      return this.top + this.lHeight * this.scale;
    },
    hVisible () {
      return this.left < this.cw && this.right > 0;
    },
    vVisible () {
      return this.top < this.ch && this.bottom > 0;
    },
    visible () {
      return (this.hVisible && this.vVisible && this.step > 4) || this.step <= 4;
    }
  }
}
</script>
